#include "Python.h"

char *find_site(void)
{
    char *app_site_dir = 0;
    PyObject *module = 0;
    PyObject *result = 0;
    PyObject *result2 = 0;
    PyObject *module_dict = 0;
    PyObject *func = 0;

    module = PyImport_ImportModule((char *)"Site"); /* new ref */
    if (module == 0)
    {
	PyErr_Print();
	printf("Couldn't find python module Site\n");
	goto out;
    }
    printf("module = %p\n", module);
    module_dict = PyModule_GetDict(module); /* borrowed */
    if (module_dict == 0)
    {
	PyErr_Print();
	printf("Couldn't find read python module Site\n");
	goto out;
    }
    func = PyDict_GetItemString(module_dict, "find_site"); /* borrowed */
    if (func == 0)
    {
	PyErr_Print();
	printf("Couldn't find Site.find_site\n");
	goto out;
    }
    result = PyEval_CallObject(func, NULL); /* new ref */
    if (result == 0)
    {
	PyErr_Print();
	printf("Couldn't run Site.find_site\n");
	goto out;
    }
    else if (result == Py_None)
    {
	printf("Couldn't find site\n");
	goto out;
    }
    result2 = PyEval_CallObject(func, NULL); /* new ref */
    printf("result = %p\n", result);
    app_site_dir = PyString_AsString(result); /* borrowed */
    if (app_site_dir == 0)
    {
	PyErr_Print();
	printf("Couldn't read result from Site.find_site\n");
	goto out;
    }
    app_site_dir = strdup(app_site_dir); /* keep in our own memory */
    if (*app_site_dir)
    {
	printf("Found Site at %s\n", app_site_dir);
    }
    else
	printf("Could not find Site\n");
out:;
    printf("result = %p decref (%d)\n", result, Py_REFCNT(result));
    printf("module = %p module (%d)\n", module, Py_REFCNT(module));
    Py_XDECREF(result);
    Py_XDECREF(module);

    return app_site_dir;
}

int main(int argc, char **argv)
{
    Py_Initialize();
    printf("py version: %s\n", Py_GetVersion());
    char *site = find_site();
    printf("Site = %s\n", site);
    free(site);
}
